#!/usr/bin/perl -w

# Copyright (c) 2001 imacat
# vҦ (c) 2001 ̺
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# {OۥѳnAziHӦۥѳn|] Free Software Foundation
# ^X GNU qΤ@\iұڡ] GNU General Public License ^ĤG
# ӭקMsoGo@{AΪ̦ۥѿܨϥΥsC
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# oGo@{تOƱ楦ΡASOCƦܨSAXSwت
# tOCԲӪpаѾ\ GNU qΤ@\iҡC
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# zӤwgM{@_@ GNU qΤ@\iҪƥCpG٨SAg
# HG Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# ɮצW:	Install.PL
# ɮ׻:	Perl ۰ʦw˫O{
# ɮת:	2.1.2
# ɮק@:	̺ <imacat@mail.imacat.idv.tw>
# Z:	2001-05-18
# vr:	(c) 2001 ̺

# Filename:	Install.PL
# Description:	Perl script to install the programs.
# Version:	2.1.2
# Author:	imacat <imacat@mail.imacat.idv.tw>
# Date:		2001-05-18
# Copyright:	(c) 2001 imacat

use strict;
use Fcntl qw(:flock);
use Getopt::Long qw(GetOptions);
use File::Copy qw(copy);
use Cwd qw(cwd);
use Sys::Hostname qw(hostname);
use File::Basename qw(fileparse dirname);
use File::Spec::Functions qw(file_name_is_absolute catdir catfile splitdir curdir updir devnull);
use Config qw(%Config);

use vars qw($THIS_PATH $THIS_FILE $VERNO $VERSTR);
# Obtain my own filename and path o{ɦWMҦb|
($THIS_FILE, $THIS_PATH) = fileparse $0;
# The version number and the version string sMr
*VERNO = \"2.1.2";
$VERSTR = "$THIS_FILE v$VERNO by imacat <imacat\@mail.imacat.idv.tw>";

# Global variables ܼ
use vars qw($CACHED %CACHE $PERLLOC @PERLVER @OS @INCLUDES @FILESLIST @PERLCF %PERLCF @PMLIST %OPTIONS %OPTARGS @EXTFILES %EXTFILES @DIST %DIST @INSTALL %INSTALL @MISCOPT %MISCOPT %MESSAGES);


#############################################
##  The settings of the script {]w  ##
#############################################
use vars qw($CONF_FILE $CONF_CACHE $CONF_SIZELIMIT $VERBOSE);
*CONF_FILE = \"config.in";	# The configuration file ]w
*CONF_CACHE = \"config.cache";	# The cache file w˳]wȦs
*CONF_SIZELIMIT = \100000;	# The size limit of the configuration files ]wɪjpW
$VERBOSE = 1;			# The message level T


main();
exit 0;


###########################
##  Main program D{  ##
###########################
sub main {
	local ($_, %_);
	
	# Turn on auto flush YܰT
	$| = 1;
	# The umask for file creation ɪ umask
	umask 0022;
	
	# Read the configuration Ū]w
	read_conf ();
	# Get the options oROCѼ
	get_opts ();
	# Print the message only ܰT
	print_message ();
	# Read the cached settings ŪWw˪]w
	read_cache ();
	# Performing uninstall Ѱw
	uninstall_files ();
	# Check the package completeness ˬd{ɮ׬O_
	check_package ();
	# Check the OS ˬd@~t
	check_os ();
	# Check the perl location ˬd perl |
	check_perlloc ();
	# Check the perl version ˬd perl 
	check_perlver ();
	# Check the required perl configuration ˬdһݪ perl \
	check_perlcf ();
	# Check the required perl modules ˬdһݪ perl Ҳ
	check_pm ();
	# Check the external files ˬd̪ۨɮ׵{
	check_extfiles ();
	# Check the miscellaneous options ˬd]w
	check_options ();
	# Check the distination directories ˬdw˪ؿ
	check_dist ();
	# Save these settings N]ws
	save_cache ();
	
	# Install the files wɮ
	install_files ();
	
	print "\nInstallation finished. " . (time() - $^T) . " second(s) elapsed.\n" if $VERBOSE > 0;
	return;
}

# Read the configuration Ū]w
sub read_conf {
	local $_;
	my ($file, $content, @lines, $l, $name);
	
	# If the configuration file is valid ˬd]wɯण
	$file = catfile $THIS_PATH, $CONF_FILE;
	die "$THIS_FILE: Configuration file $file not exists" unless -e $file;
	die "$THIS_FILE: Configuration file $file not a file" unless -f $file;
	die "$THIS_FILE: Configuration file $file not readable" unless -r $file;
	die "$THIS_FILE: Configuration file $file no content" unless -s $file;
	die "$THIS_FILE: Configuration file $file too big" unless -s $file < $CONF_SIZELIMIT;
	
	# Read the configuration file Ū]w
	open (DATA, $file) || die "$THIS_FILE: $!";
	flock (DATA, LOCK_SH) || die "$THIS_FILE: $!";
	(@lines = <DATA>) || die "$THIS_FILE: $!";
	flock (DATA, LOCK_UN) || die "$THIS_FILE: $!";
	close (DATA) || die "$THIS_FILE: $!";
	
	# Remove the comments and the blank lines hѩMťզ
	foreach (@lines) {
		s/([^"'#]+|"(?:\\"|[^"])*"?|'(?:\\'|[^'])*'?|#.*)/ord $1 == ord "#"? "": $1/egs;
		s/\s+$//;
	}
	@lines = grep $_ ne "", @lines;
	
	for ($l = 0; $l < @lines; $l++) {
		# Required perl version һݪ perl 
		if ($lines[$l] =~ /^\s*PERLVER\s+(\S.*)$/i) {
			@_ = get_list ($1);
			@PERLVER = @_ if (grep(/\D/, @_) == 0);
		# Required OSs һݪ@~t
		} elsif ($lines[$l] =~ /^\s*OS\s+(\S.*)$/i) {
			push @OS, get_list ($1);
		# Required perl configuration һݪ perl \
		} elsif ($lines[$l] =~ /^\s*PERLCF\s+(\S.*)$/i) {
			$name = get_value ($1);
			# Add to the perl configuration list [iһ perl \M
			push @PERLCF, $name if grep($_ eq $name, @PERLCF) == 0;
			$l++;
			# From PERLCF to END PERLCF q PERLCF  END PERLCF
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+PERLCF$/i) {
				# Other settings o]w
				if ($lines[$l] =~ /^\s*(\S+)\s+(\S.*)$/i) {
					$PERLCF{$name . "_" . lc $1} = get_value ($2);
				}
				$l++;
			}
		# Required perl modules һݪ perl Ҳ
		} elsif ($lines[$l] =~ /^\s*PMLIST\s+(\S.*)$/i) {
			push @PMLIST, get_list ($1);
		# Files for checking package completeness ˬd{ʮɭnˬdɮ
		} elsif ($lines[$l] =~ /^\s*FILESLIST\s+(\S.*)$/i) {
			push @FILESLIST, get_list ($1);
		# Required external files ˬdΨ쪺~{
		} elsif ($lines[$l] =~ /^\s*EXTFILE\s+(\S.*)$/i) {
			$name = get_value ($1);
			# Add to the external file list [i~{M
			push @EXTFILES, $name if grep($_ eq $name, @EXTFILES) == 0;
			$l++;
			# From EXTFILE to END EXTFILE q EXTFILE  END EXTFILE
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+EXTFILE$/i) {
				# Corresponding command line option ROCﶵ
				if ($lines[$l] =~ /^\s*OPTION\s+(\S.*)$/i) {
					$OPTARGS{$name} = get_value ($1);
					$EXTFILES{$name . "_option"} = get_value ($1);
				# Attributes and search paths ɮݩʩMjM|
				} elsif ($lines[$l] =~ /^\s*(ATTR|PATH)\s+(\S.*)$/i) {
					$EXTFILES{$name . "_" . lc $1} = $2;
				# Other settings o]w
				} elsif ($lines[$l] =~ /^\s*(\S+)\s+(\S.*)$/i) {
					$EXTFILES{$name . "_" . lc $1} = get_value ($2);
				}
				$l++;
			}
		# The distination directories nw˪ؿ
		} elsif ($lines[$l] =~ s/^\s*DIST\s+(\S.*)$//i) {
			$name = get_value ($1);
			# Corresponding command line option ROCﶵ
			$OPTARGS{$name} = "$name=s";
			# Add to the distination directory list [iw˥ؿM
			push @DIST, $name if grep($_ eq $name, @DIST) == 0;
			$l++;
			# From DIST to END DIST q DIST  END DIST
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+DIST$/i) {
				# Other settings o]w
				if ($lines[$l] =~ /^\s*(\S+)\s+(\S.*)$/i) {
					$DIST{$name . "_" . lc $1} = get_value ($2);
				}
				$l++;
			}
		# The installation infomation nw˪ɮ
		} elsif ($lines[$l] =~ /^\s*INSTALL\s+(\S.*)$/i) {
			$name = get_value ($1);
			# Add to the installation file list [iwɮײM
			push @INSTALL, $name if grep($_ eq $name, @INSTALL) == 0;
			$l++;
			# From INSTALL to END INSTALL q INSTALL  END INSTALL
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+INSTALL$/i) {
				# Other settings o]w
				if ($lines[$l] =~ /^\s*(\S+)\s+(\S.*)$/i) {
					$INSTALL{$name . "_" . lc $1} = get_value ($2);
				}
				$l++;
			}
			# Record on the distination directory infomation Obw˥ؿƤ
			if (!exists $DIST{$INSTALL{$name . "_below"} . "_files"}) {
				$DIST{$INSTALL{$name . "_below"} . "_files"} = $INSTALL{$name . "_pos"};
			} else {
				$DIST{$INSTALL{$name . "_below"} . "_files"} .= ", " . $INSTALL{$name . "_pos"};
			}
		# Miscelleous options oﶵ
		} elsif ($lines[$l] =~ /^\s*OPTION\s+(\S.*)$/i) {
			$name = get_value ($1);
			# Add to the miscelleous options list [ioﶵM
			push @MISCOPT, $name if grep($_ eq $name, @MISCOPT) == 0;
			$l++;
			# From OPTION to END OPTION q OPTION  END OPTION
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+OPTION$/i) {
				# Option type ﶵʽ
				if ($lines[$l] =~ /^\s*TYPE\s+(\S.*)$/i) {
					$_ = lc get_value ($1);
					$MISCOPT{$name . "_type"} = $_;
					# Boolean u]]w^A]^
					if ($_ eq "boolean") {
						$OPTARGS{$name} = "$name!";
					# Text string rr
					} elsif ($_ eq "string") {
						$OPTARGS{$name} = "$name=s";
					# Number 
					} elsif ($_ eq "number") {
						$OPTARGS{$name} = "$name=i";
					# Decimal p
					} elsif ($_ eq "decimal") {
						$OPTARGS{$name} = "$name=f";
					}
				# Other settings o]w
				} elsif ($lines[$l] =~ /^\s*(\S+)\s+(\S.*)$/i) {
					$MISCOPT{$name . "_" . lc $1} = get_value ($2);
				}
				$l++;
			}
		# Infomative messages ܰT
		} elsif ($lines[$l] =~ /^\s*MESSAGE\s+(\S.*)$/i) {
			$name = get_value ($1);
			# Corresponding command line option ROCﶵ
			$OPTARGS{$name} = "$name";
			$l++;
			$MESSAGES{$name} = "";
			# From MESSAGE to END MESSAGE q MESSAGE  END MESSAGE
			while ($l < @lines && $lines[$l] !~ /^\s*END\s+MESSAGE$/i) {
				# Preserve all ʤʦsU
				$MESSAGES{$name} .= $lines[$l] . "\n";
				$l++;
			}
		}
	}
	
	return;
}

# Get the options oROCѼ
sub get_opts {
	local ($_, %_);
	# Set the options hash ]wѼƲ
	%_ = qw();
	foreach (keys %OPTARGS) {
		$_{$OPTARGS{$_}} = \$OPTIONS{$_};
	}
	
	# Add the build-in options [Wتw]Ѽ
	$_{"uninstall"} = \$OPTIONS{"uninstall"};
	$_{"quiet|silent"} = \$OPTIONS{"quiet"};
	$_{"+include=s"} = \@INCLUDES;
	
	# Get the options oROCѼ
	GetOptions (%_) || exit 1;
	# Set the quiet mode ]wwRҦ
	$VERBOSE = 0 if defined $OPTIONS{"quiet"};
	return;
}

# Print the message only ܰT
sub print_message {
	local $_;
	# Check each available messages @Ӥ@ӰTˬd
	foreach (keys %MESSAGES) {
		# If this option is specified pGwnܳoӰT
		if (defined $OPTIONS{$_}) {
			# Print the message ܰT
			print replace_vars($MESSAGES{$_});
			# No need further execution {
			exit 0;
		}
	}
	return;
}

# Read the cached settings ŪWw˪]w
sub read_cache {
	local $_;
	my @includes;
	$_ = catfile $THIS_PATH, $CONF_CACHE;
	# If the cache file is valid Ww˳]wsɯण
	return if !-e $_ || !-f $_ || !-r $_ || !-s $_ || !-s $_ >= $CONF_SIZELIMIT ;
	
	print "Reading from $_... " if $VERBOSE > 0;
	# Read the cached settings ŪWw˪]w
	open (DATA, $_) || die "$THIS_FILE: $!";
	flock (DATA, LOCK_SH) || die "$THIS_FILE: $!";
	(@_ = <DATA>) || die "$THIS_FILE: $!";
	flock (DATA, LOCK_UN) || die "$THIS_FILE: $!";
	close (DATA) || die "$THIS_FILE: $!";
	
	# Process one by one @@Ū
	foreach (@_) {
		chomp;
		# If this line is valid ˬdo@ण
		next unless /^(\S+)\s(\S+)$/;
		# Addition @INC paths sW @INC |
		if ($1 eq "include") {
			push @includes, get_value ($2);
		# Ordinary settings o@]w
		} else {
			$CACHE{$1} = get_value ($2);
		}
	}
	
	# Ordinary settings Bz@]w
	foreach (keys %CACHE) {
		# If no such option exists Soӿﶵ
		next unless exists $OPTIONS{$_};
		# It is specified in the arguments oӿﶵts]w
		next if defined $OPTIONS{$_};
		# Set as default _hAw]]w
		$OPTIONS{$_} = $CACHE{$_};
	}
	
	# If additional @INC is specified StwsW @INC |
	@INCLUDES = @includes if @INCLUDES == 0 && @includes > 0;
	
	# Cache file read ŪW]wȤF
	$CACHED = 1;
	print "done\n" if $VERBOSE > 0;
	return;
}

# Performing uninstall Ѱw
sub uninstall_files {
	local $_;
	my $file;
	# Should we uninstall? nѰw˶ܡH
	return if !exists $OPTIONS{"uninstall"} || !defined $OPTIONS{"uninstall"};
	
	print "Performing uninstall\n" if $VERBOSE > 0;
	# Cache file not read SŪW]w
	die "$THIS_FILE: Cache file not found" if !defined $CACHED;
	# Remove all the files @@Rɮ
	foreach $file (@INSTALL) {
		# Get the file path oɮ׸|
		$_ = catfile $CACHE{$INSTALL{$file . "_below"}}, $INSTALL{$file . "_pos"};
		print "Removing $_... " if $VERBOSE > 0;
		# Successfully removed Rɦ\
		if (unlink($_)) {
			print "done\n" if $VERBOSE > 0;
		# Remove failed Rɥ
		} else {
			print "$!\n" if $VERBOSE > 0;
		}
	}
	
	print "\nUninstallation finished. " . (time() - $^T) . " second(s) elapsed.\n" if $VERBOSE > 0;
	# No need further execution {
	exit 0;
}

# Check the package completeness ˬd{ɮ׬O_
sub check_package {
	local $_;
	my $file;
	# If there's any file to check ɮ׭nˬdܡH
	return if @FILESLIST == 0;
	
	print "Checking if your package is complete... " if $VERBOSE > 0;
	# Check the package files @@ˬdɮ
	foreach (@FILESLIST) {
		# Get the file path oɮ׸|
		$file = catfile $THIS_PATH, $_;
		# If this file is valid oɮׯζܡH
		if (!-e $file || !-f $file || !-r $file) {
			print "no\n$_ is invalid. Please download from the original again.\n" if $VERBOSE > 0;
			die "$THIS_FILE: Failed checking $_";
		}
	}
	print "yes\n" if $VERBOSE > 0;
	return;
}

# Check the OS ˬd@~t
sub check_os {
	local ($_, %_);
	# OS is not limited @~tΤ
	return if @OS == 0;
	
	print "Checking your operating system... " if $VERBOSE > 0;
	# Obtain the available OS list oiΪ@~tβM
	foreach (@OS) {
		$_{$_} = 1;
	}
	undef $_;
	# If it is DOS/Win pGO DOS/Windows
	if ($^O =~ /^(?:(ms)?(dos|win(32|nt)?))/i) {
		# Is DOS/Win permitted? DOS/Windows UiHܡH
		$_ = 1 if exists $_{"MSWin"};
	# If it is MacOS pGO MacOS
	} elsif ($^O =~ /^MacOS$/i) {
		# Is MacOS permitted? MacOS UiHܡH
		$_ = 1 if exists $_{"MacOS"};
	# If it is VMS pGO VMS
		# Is VMS permitted? VMS UiHܡH
	} elsif ($^O =~ /^VMS$/i) {
		$_ = 1 if exists $_{"VMS"};
	# Or, assume it is UNIX _hAO UNIX
	} else {
		# Is UNIX permitted? UNIX UiHܡH
		$_ = 1 if exists $_{"UNIX"};
	}
	# If the previous test failed pGezեѤF
	if (!defined $_) {
		print "$^O\nThis program cannot be run on $^O. It can only be run on " . join (", ", @OS) . ".\n" if $VERBOSE > 0;
		die "$THIS_FILE: Invalid Operating System $^O";
	}
	print "$^O\n" if $VERBOSE > 0;
	return;
}

# Check the perl location ˬd perl |
sub check_perlloc {
	local $_;
	my $path;
	# Don't check if it is unavailable pGLkT{ perl mANF
	return if lc $^X eq "perl";
	print "Checking your perl location... " if $VERBOSE > 0;
	# Obtain from $^X q $^X ӧ
	$PERLLOC = rel2abs($^X);
	print "$PERLLOC\n";
	return;
}

# Check the perl version ˬd perl 
sub check_perlver {
	local $_;
	# Perl version is not specified pGSw perl 
	return if @PERLVER == 0;
	
	print "Checking your perl version... " if $VERBOSE > 0;
	# New checking method from $^V sˬd覡A $^V ˬd
	if (defined $^V) {
		# Turn every byte into its ACSII number NCӦ줸ରNƦr
		for ($_ = 0; $_ < length $^V; $_++) {
			push @_, ord substr ($^V, $_, 1);
		}
		# Join the numbers into the version no. NƦrզXX
		$_ = join (".", @_);
		# Version too older 
		if ($^V lt chr($PERLVER[0]) . chr($PERLVER[1]) . chr($PERLVER[2])) {
			print "$_\nThis program needs perl " . join(".", @PERLVER) . " or above. Please upgrade to the newest version.\n" if $VERBOSE > 0;
			die "$THIS_FILE: Perl version too old";
		} else {
			print "$_\n" if $VERBOSE > 0;
		}
	# Old checking method from $] ªˬd覡A $] ˬd
	} else {
		# Version too older 
		if ($] < $PERLVER[0] + $PERLVER[1]/1000 + $PERLVER[2]/1000000) {
			print "$]\nThis program needs perl " . ($PERLVER[0] + $PERLVER[1]/1000 + $PERLVER[2]/1000000) . " or above. Please upgrade to the newest version.\n" if $VERBOSE > 0;
			die "$THIS_FILE: Perl version too old";
		} else {
			print "$]\n" if $VERBOSE > 0;
		}
	}
	return;
}

# Check the required perl configuration ˬdһݪ perl \
sub check_perlcf {
	local $_;
	# If there's any perl configuration to check  perl \nˬdܡH
	return if @PERLCF == 0;
	
	# Check the perl configurations @Ӥ@ˬd
	foreach (@PERLCF) {
		print "Checking for $_... " if $VERBOSE > 0;
		# If perl is not configured to do so pG Perl S䴩oӥ\
		if (!exists $Config{$_} || !defined $Config{$_} || $Config{$_} eq "") {
			print "no\n" . $PERLCF{$_ . "_failmsg"} . "\n";
			die "$THIS_FILE: Failed checking $_";
		} elsif (exists $PERLCF{$_ . "_attr"} && !test_file ($Config{$_}, get_list ($PERLCF{$_ . "_attr"}))) {
			print "no\n" . $PERLCF{$_ . "_attr"} . $PERLCF{$_ . "_failmsg"} . "\n";
		} else {
			print "yes\n";
		}
	}
	return;
}

# Check the required perl modules ˬdһݪ perl Ҳ
sub check_pm {
	local $_;
	my ($pm, $file, $path, $found);
	# If there's any perl module to check  perl ҲխnˬdܡH
	return if @PMLIST == 0;
	
	# Add the additional @INC [WsW @INC
	push @INC, @INCLUDES;
	# Search the perl modules @Ӥ@ˬd
	foreach $pm (@PMLIST) {
		print "Checking for $pm... " if $VERBOSE > 0;
		# Split into directory and file name ΦؿMɦW
		@_ = split /::/, $pm;
		$_[@_-1] .= ".pm";
		undef $found;
		$_ = catfile @_;
		eval {
			local $SIG{'__WARN__'} = sub { die $_[0]; };
			require $_;
		};
		if ($@ eq "") {
			print "yes\n" if $VERBOSE > 0;
		# If not found pGS쪺
		} else {
			print "no\n$@" if $VERBOSE > 0;
			die "$THIS_FILE: Failed checking $pm";
		}
	}
	return;
}

# Check the external files ˬd̪ۨɮ׵{
sub check_extfiles {
	local $_;
	my ($file, $path, @attrs);
	# If there's any file to check ɮ׭nˬdܡH
	return if @EXTFILES == 0;
	
	# Check the external files @@ˬdɮ
	foreach $file (@EXTFILES) {
		# The attributes to check ɮ׭nˬdݩ
		@attrs = qw();
		@attrs = get_list ($EXTFILES{$file . "_attr"}) if exists $EXTFILES{$file . "_attr"};
		undef $path;
		# If the location is specified from the command line YqROCwm
		if (defined $OPTIONS{$file}) {
			$path = replace_vars($OPTIONS{$file});
			print "Checking your $file... " if $VERBOSE > 0;
			$path = rel2abs($path);
			# Tests failed ˬd
			if (!test_file($path, @attrs)) {
				print "no\nThat doesn't look like a valid $file.\n" if $VERBOSE > 0;
				undef $path;
			} else {
				print "yes\n" if $VERBOSE > 0;
			}
		}
		# If the path was not found yet Y٨Sɮ
		if (!defined $path) {
			print "Checking for $file... " if $VERBOSE > 0;
			# Search from the default paths qw]mM
			foreach (get_list ($EXTFILES{$file . "_path"})) {
				# Tests failed ˬd
				if (test_file($_, @attrs)) {
					$path = $_;
					print "$path\n" if $VERBOSE > 0;
					last;
				}
			}
			print "failed\n" if !defined $path && $VERBOSE > 0;
		}
		# If not found yet, ask till we found Y٧䤣Aݨ즳
		while (!defined $path) {
			print "Where is the location of $file: ";
			$_ = <STDIN>;
			chomp;
			# No input SJ
			if ($_ eq "") {
				print "I need to know the location of $file.\n";
			# Tests failed ˬd
			} elsif (!test_file($_, @attrs)) {
				print "That doesn't look like a valid $file.\n";
			} else {
				$path = $_;
			}
		}
		# Save the result location 쪺ms_
		$EXTFILES{$file} = $path;
	}
	return;
}

# Check the miscellaneous options ˬd]w
sub check_options {
	local $_;
	my $opt;
	# If there's any option to check ]wnˬdܡH
	return if @MISCOPT == 0;
	
	# Check the options @@ˬdﶵ
	foreach $opt (@MISCOPT) {
		# If the dependent option does not meet the condition Y̪ۨﶵű
		if (exists $MISCOPT{$opt . "_depend"} && $MISCOPT{$opt . "_depend"} =~ /^(\S+)\s+(\S+)$/ && defined $OPTIONS{$1} && $OPTIONS{$1} ne $2) {
			# Remove its value Roӿﶵ
			undef $OPTIONS{$opt};
			# No need to process κޤF
			next;
		}
		# No need to process if it is set pG]wANκޤF
		next if defined $OPTIONS{$opt};
		# If the default should be implied when it is not set pGS]wɭԡAnιw]Ȫ
		if (exists $MISCOPT{$opt . "_imply"} && exists $MISCOPT{$opt . "_default"}) {
			# Use the implied default Nιw]
			$OPTIONS{$opt} = replace_vars ($MISCOPT{$opt . "_default"});
			next;
		}
		# No need to process if it is not required pGOD]wiANޤF
		next if !exists $MISCOPT{$opt . "_require"};
		# Default to empty string if default not set YSw]ȡAw]ȬŦr
		$MISCOPT{$opt . "_default"} = "" unless exists $MISCOPT{$opt . "_default"};
		$MISCOPT{$opt . "_default"} = replace_vars ($MISCOPT{$opt . "_default"});
		# Ask till we get the answer ݨ즳G
		while (!defined $OPTIONS{$opt}) {
			print $MISCOPT{$opt . "_prompt"} . " [" . $MISCOPT{$opt . "_default"} . "]: ";
			$OPTIONS{$opt} = <STDIN>;
			chomp $OPTIONS{$opt};
			# Set to the default if enter is pressed Y Enter A]w]
			$OPTIONS{$opt} = $MISCOPT{$opt . "_default"} if $OPTIONS{$opt} eq "";
			# Try again if empty YSGAAդ@
			undef $OPTIONS{$opt} if $OPTIONS{$opt} eq "";
		}
	}
	return;
}

# Check the distination directories ˬdw˪ؿ
sub check_dist {
	local $_;
	my ($dist, $path, $file, @files);
	# If there's any distination directory to check w˥ؿnˬdܡH
	return if @DIST == 0;
	
	# Check the distinations @@ˬdw˥ؿ
	foreach $dist (@DIST) {
		# Get the files belong to that directory oӥؿUɮ
		@files = get_list ($DIST{$dist . "_files"});
		undef $path;
		# If the distination is specified from the command line YqROCww˥ؿ
		if (defined $OPTIONS{$dist}) {
			print "Checking your $dist... " if $VERBOSE > 0;
			$path = rel2abs($OPTIONS{$dist});
			# Check the files @@ˬdnw˪ɮ
			foreach $file (@files) {
				$_ = is_installable (catfile ($path, $file));
				# If error occurs YˬdXD
				if (defined $_) {
					print "no\n$_\n" if $VERBOSE > 0;
					undef $path;
					last;
				}
			}
			print "OK\n" if defined $path && $VERBOSE > 0;
		}
		# If no valid path yet, ask till we have Y٨SiΪw˥ؿAݨ즳
		while (!defined $path) {
			print $DIST{$dist . "_prompt"} . " [" . $DIST{$dist . "_default"} . "]: ";
			$path = <STDIN>;
			chomp $path;
			# Set to the default if enter is pressed Y Enter A]w]
			$path = $DIST{$dist . "_default"} if $path eq "";
			$path = rel2abs($path);
			# Check the files @@ˬdnw˪ɮ
			foreach $file (@files) {
				$_ = is_installable (catfile ($path, $file));
				# If error occurs YˬdXD
				if (defined $_) {
					print "$_\n";
					undef $path;
					last;
				}
			}
		}
		# Save the result distination nΪw˥ؿs_
		$DIST{$dist} = $path;
	}
	return;
}

# Save these settings N]ws
sub save_cache {
	local $_;
	my ($file, $key);
	# Check if it is possible to save the cache file ˬdणs
	$file = catfile $THIS_PATH, $CONF_CACHE;
	# If file exists pGoɮ
	if (-e $file) {
		# Check if it is writable ˬdɮׯणs
		return if !-f $file || !-w $file;
	# If file not exists pGSoɮ
	} else {
		# Check if this path is writable ˬdؿणs
		return if !-d $THIS_PATH || !-w $THIS_PATH;
	}
	
	print "Creating $file... " if $VERBOSE > 0;
	$_ = "";
	# Record the distination directories Ow˥ؿ
	foreach $key (@DIST) {
		$_ .= "$key\t$DIST{$key}\n" if defined $DIST{$key};
	}
	# Record the external file locations O̪ۨɮצm
	foreach $key (@EXTFILES) {
		$_ .= "$key\t$EXTFILES{$key}\n" if defined $EXTFILES{$key};
	}
	# Record the miscelleous options Ooﶵ
	foreach $key (@MISCOPT) {
		$_ .= "$key\t$OPTIONS{$key}\n" if defined $OPTIONS{$key};
	}
	# Record the additional @INC paths OsW @INC |
	foreach $key (@INCLUDES) {
		$_ .= "include\t$key\n";
	}
	# Save the records s
	open (DATA, ">$file") || die "$THIS_FILE: $!";
	flock (DATA, LOCK_EX) || die "$THIS_FILE: $!";
	(print DATA) || die "$THIS_FILE: $!";
	flock (DATA, LOCK_UN) || die "$THIS_FILE: $!";
	close (DATA) || die "$THIS_FILE: $!";
	print "done\n" if $VERBOSE > 0;
	return;
}

# Install the files wɮ
sub install_files {
	local $_;
	my ($file, $src, $dist, $key, $var, $value, @paths);
	
	print "\nNow we will install everything\n" if $VERBOSE > 0;
	# Install each file @@w
	foreach $file (@INSTALL) {
		# Get the source and the distination location oɩMw˥تɪ|
		$dist = catfile $DIST{$INSTALL{$file . "_below"}}, $INSTALL{$file . "_pos"};
		$src = catfile $THIS_PATH, $file;
		print "Installing $file\n" if $VERBOSE > 0;
		
		# Create the necessary directories إߩһݪؿ
		$_ = dirname $dist;
		@_ = splitdir $_;
		# Get the list of directories to create onتؿM
		@paths = qw();
		while (!-e $_) {
			unshift @paths, $_;
		} continue {
			pop @_;
			$_ = catdir @_;
		}
		# Make the directories إߥؿ
		foreach (@paths) {
			print " Creating directory $_... " if $VERBOSE > 0;
			mkdir ($_, 0755) || die "$THIS_FILE: Unable to create directory $_: $!";
			print "done\n" if $VERBOSE > 0;
		}
		
		# Create new file only. Don't override uطsɡCYwgFNLAn\
		if (exists $INSTALL{$file . "_create_new_only"} && -e $dist) {
			print " $dist exists. Skipped\n" if $VERBOSE > 0;
		
		# Create an empty file إߪɮסAqs}l
		} elsif (exists $INSTALL{$file . "_create_as_empty"}) {
			print " Creating empty file $dist... " if $VERBOSE > 0;
			copy (devnull, $dist) || die "$THIS_FILE: Unable to create an empty $dist: $!";
			print "done\n" if $VERBOSE > 0;
		
		# Modify with the settings ɮת]w
		} elsif (exists $INSTALL{$file . "_modify"}) {
			# Read the source file Ūl
			print " Reading from $src... " if $VERBOSE > 0;
			open (DATA, $src) || die "$THIS_FILE: Unable to open $src: $!";
			flock (DATA, LOCK_SH) || die "$THIS_FILE: Unable to lock $src: $!";
			(@_ = <DATA>) || die "$THIS_FILE: Unable to read from $src: $!";
			flock (DATA, LOCK_UN) || die "$THIS_FILE: Unable to unlock $src: $!";
			close (DATA) || die "$THIS_FILE: Unable to close $src: $!";
			$_ = join ("", @_);
			print "done\n" if $VERBOSE > 0;
			
			# Modify the content 鷺e
			print " Modifying $file... " if $VERBOSE > 0;
			# Modify the perl location  Perl m
			s/^#!\S+/#!$PERLLOC/ if defined $PERLLOC;
			# Add the additional @INC paths [WsW @INC |
			s/^(.*?\nBEGIN\s*\{\s*push\s+\@INC,\s*qw\().*?(?=\);\s*\})/$1 . join (" ", @INCLUDES)/se;
			# Modify the location of the external files ̪ۨ~ɮצm
			foreach $key (@EXTFILES) {
				# Skip if no modification is needed YΧNL
				next unless exists $EXTFILES{$key . "_var"};
				$value = $EXTFILES{$key};
				# Default to nothing if not set YS]AN]
				$value = "" if !defined $value;
				# Escape the special characters ]wSr
				$value =~ s/\@/\\\@/;
				$value =~ s/\$/\\\$/;
				$value =~ s/\"/\\"/;
				$var = $EXTFILES{$key . "_var"};
				# Set as reference HOm]w
				if ($var =~ /^\*/) {
					s/^(.*?\n\Q$var\E\s*=\s*\\")(?:\\\\|\\"|[^\\"])*(?=";)/$1$value/;
				# Set as variable HܼƳ]w
				} else {
					s/^(.*?\n\Q$var\E\s*=\s*")(?:\\\\|\\"|[^\\"])*(?=";)/$1$value/;
				}
			}
			# Modify the miscellaneous options ]w
			foreach $key (@MISCOPT) {
				# Skip if no modification is needed YΧNL
				next unless exists $MISCOPT{$key . "_var"};
				$value = $OPTIONS{$key};
				# Default to nothing if not set YS]AN]
				$value = "" if !defined $value;
				# Escape the special characters ]wSr
				$value =~ s/\@/\\\@/;
				$value =~ s/\$/\\\$/;
				$value =~ s/\"/\\"/;
				$var = $MISCOPT{$key . "_var"};
				# Set as reference HOm]w
				if ($var =~ /^\*/) {
					# String r
					if (lc $MISCOPT{$key . "_type"} eq "string") {
						s/^(.*?\n\Q$var\E\s*=\s*\\")(?:\\\\|\\"|\\\@|\\\$|[^\\"])*(?=";)/$1$value/s;
					# Boolean or number uAμƦr
					} else {
						s/^(.*?\n\Q$var\E\s*=\s*\\)[^;]*(?=;)/$1$value/s;
					}
				# Set as variable HܼƳ]w
				} else {
					# String r
					if (lc $MISCOPT{$key . "_type"} eq "string") {
						s/^(.*?\n\Q$var\E\s*=\s*")(?:\\\\|\\"|\\\@|\\\$|[^\\"])*(?=";)/$1$value/s;
					# Boolean or number uAμƦr
					} else {
						s/^(.*?\n\Q$var\E\s*=\s*)[^;]*(?=;)/$1$value/s;
					}
				}
			}
			print "done\n" if $VERBOSE > 0;
			
			# Write to the distination file giw˪ت
			print " Writing to $dist... " if $VERBOSE > 0;
			open (DATA, ">$dist") || die "$THIS_FILE: Unable to open $dist: $!";
			flock (DATA, LOCK_EX) || die "$THIS_FILE: Unable to lock $dist: $!";
			(print DATA) || die "$THIS_FILE: Unable to write to $dist: $!";
			flock (DATA, LOCK_UN) || die "$THIS_FILE: Unable to unlock $dist: $!";
			close (DATA) || die "$THIS_FILE: Unable to close $dist: $!";
			print "done\n" if $VERBOSE > 0;
		
		# No need to modify -- copy only ΧA
		} else {
			print " Copying from $src to $dist... " if $VERBOSE > 0;
			copy ($src, $dist) || die "$THIS_FILE: $!";
			print "done\n" if $VERBOSE > 0;
		}
		
		# Setting the permission ]wɮv
		if (exists $INSTALL{$file . "_perm"}) {
			print " Setting permission to " . $INSTALL{$file . "_perm"} . "... " if $VERBOSE > 0;
			chmod (oct $INSTALL{$file . "_perm"}, $dist) || die "$THIS_FILE: Unable to change the permission of $dist to " . $INSTALL{$file . "_perm"} . ": $!";
			print "done\n" if $VERBOSE > 0;
		}
	}
	
	return;
}

# Get a quoted value oA_Ӫ
sub get_value {
	local $_;
	$_ = $_[0];
	# Remove the leading and trailing spaces hYť
	s/^\s*(.*?)\s*$/$1/s;
	# Remove the quotes hA
	s/([^"']+|"(?:\\"|[^"])*"?|'(?:\\'|[^'])*'?)/ord $1 == ord "\"" || ord $1 == ord "'"? eval $1: $1/eg;
	return $_;
}

# Get a quoted list from a comma seperated values oγrI}AA_ӪM
sub get_list {
	local $_;
	$_ = $_[0];
	# Get the list oM
	@_ = ("");
	s/([^"',]+|"(?:\\"|[^"])*"?|'(?:\\'|[^'])*'?|,)/if ($1 eq ",") { push @_, ""; } else { $_[@_-1] .= $1; }/eg;
	# Remove the quotes hA
	@_ = map get_value($_), @_;
	return @_;
}

# Replace variables within a string Nrꤺܼ
sub replace_vars {
	local $_;
	my ($str, $before, $var, $after);
	$str = $_[0];
	# Thers's variables inside the string rꤺnNܼ
	while ($str =~ /^(.*?)\$\(([^\(\)]+)\)(.*)$/si) {
		$before = $1;
		$var = lc $2;
		$after = $3;
		# Not system variables Otܼ
		unless ($var =~ s/^\*sys:(.+)\*$/$1/) {
			# Set in the options pGﶵ]
			if (exists $OPTIONS{$var} && defined $OPTIONS{$var}) {
				$var = $OPTIONS{$var};
			# The default distination locations w]w˸|
			} elsif (exists $DIST{$var . "_default"} && defined $DIST{$var . "_default"}) {
				$var = $DIST{$var . "_default"};
			# The default of miscellaneous options ﶵw]
			} elsif (exists $MISCOPT{$var . "_default"} && defined $MISCOPT{$var . "_default"}) {
				$var = $MISCOPT{$var . "_default"};
			# Else, set to nothing _hA]L
			} else {
				$var = "";
			}
		# The hostname DW
		} elsif ($var eq "hostname") {
			undef $var;
			$var = hostname if !defined $var;
			$var = "localhost" if !defined $var;
		# The user account ϥΪ̱b
		} elsif ($var eq "user") {
			undef $var;
			$var = getlogin if !defined $var && defined $Config{"getlogin"};
			$var = getpwuid $< if !defined $var && defined $Config{"getpwent"};
			$var = $ENV{"USER"} if !defined $var && exists $ENV{"USER"} && $ENV{"USER"} ne "";
			$var = $ENV{"LOGNAME"} if !defined $var && exists $ENV{"LOGNAME"} && $ENV{"LOGNAME"} ne "";
			$var = "you" if !defined $var;
		# This file itself oɮתɦW
		} elsif ($var eq "thisfile") {
			$var = $THIS_FILE;
		# The version string r
		} elsif ($var eq "verstr") {
			$var = $VERSTR;
		# The version number X
		} elsif ($var eq "verno") {
			$var = $VERNO;
		# Else, set to nothing _hA]L
		} else {
			$var = "";
		}
		# Replace the variable ܼƥN
		$str = "$before$var$after";
	}
	return $str;
}

# Test a file ɮ
sub test_file {
	local ($_, %_);
	my ($file, $attrlist);
	($file, @_) = @_;
	foreach (@_) {
		$_{lc $_} = 1;
	}
	return 0 if exists $_{"exists"} && !-e $file;	# File exists ɮצsb
	return 0 if exists $_{"file"} && !-f $file;	# A regular file Oɮ
	return 0 if exists $_{"dir"} && !-d $file;	# A regular directory Oؿ
	return 0 if exists $_{"read"} && !-r $file;	# Readable iŪ
	return 0 if exists $_{"write"} && !-w $file;	# Writable ig
	return 0 if exists $_{"exec"} && !-x $file;	# Executable i
	return 0 if exists $_{"suid"} && !-u $file;	# SUID bit set ]w SUID
	return 0 if exists $_{"sgid"} && !-g $file;	# SGID bit set ]w SGID
	return 0 if exists $_{"nonzero"} && !-s $file;	# Not empty Oɮ
	return 1;
}

# Test if a file is installable ճoɮׯणw
sub is_installable {
	local $_;
	$_ = $_[0];
	$_ = rel2abs($_);
	# If the distination exists pGoɮ
	if (-e $_) {
		# A regular file? OOɮסH
		return "$_: Not a valid file" unless -f $_;
		# Overwritable? ण\H
		return "$_: Permission denied" unless -w $_;
	# If the distination not exists pGSoɮ
	} else {
		@_ = splitdir $_;
		# Trace to the first existing parent directory Wlo쪺ؿ
		while (!-e $_) {
			pop @_;
			$_ = catdir @_;
		}
		# A regular directory? OOؿH
		return "$_: Not a valid directory" unless -d $_;
		# New file creatable? णbUɡH
		return "$_: Permission denied" unless -w $_;
	}
	return;
}

# rel2abs: Convert a relative path to an absolute path ۹|ର|
sub rel2abs {
	local $_;
	my ($user, $path, $base);
	($path, $base) = @_;
	
	# Turn the base absolute Ҭ۹諸|ন|
	$base = cwd unless defined $base;
	$base = rel2abs ($base) if !file_name_is_absolute $base;
	
	# Deal the ~ home directories under UNIX b UNIX UBz ~ ϥΪ̪ڥؿ
	if (defined $Config{"d_getpwent"}) {
		@_ = splitdir ($path);
		# If start from user's home directory YOqϥΪ̮ڥؿ}l
		if ($_[0] =~ /^~(.*)$/) {
			$user = $1;
			# Get the current user if user not specified YϥΪ̨S]wAHثeϥΪ̬
			$user = getlogin if $user eq "";
			# Get the user home directory oϥΪ̮ڥؿ
			$_ = (getpwnam $user)[7];
			# Replace with the user home directory NϥΪ̮ڥؿ
			$_[0] = $_ if defined $_;
			# Compose the path զX|
			$path = catfile @_;
		}
	}
	
	# Append the current directory if relative ۹|Wثe|
	$path = catdir ($base, $path) unless file_name_is_absolute $path;
	
	@_ = splitdir ($path);			# Split into directory components Uhؿ
	# Add an empty filename level if last level is a directory ̫@hOؿɡA[WťɦWh
	push @_, "" if ($_[@_-1] eq curdir || $_[@_-1] eq updir);
	for ($_ = 1; $_ < @_; $_++) {		# Parse each level one by one @h@hR
		# If it is this directory oӥؿ
		if ($_[$_] eq curdir) {
			splice (@_, $_, 1);	# Remove this level directly ho@h
			$_--;			# The level number drop by 1 hƴ@
		# If it is the parent directory W@hؿ
		} elsif ($_ > 1 && $_[$_] eq updir && $_[$_-1] ne updir) {
			splice (@_, $_-1, 2);	# Remove this and the previous level ho@hMW@h
			$_ -= 2;		# The level number drop by 2 hƴG
		}
	}
	$path = catfile (@_);			# Compose the full path զX|
	return $path;
}

__END__

=head1 NAME

Install.PL - Perl script to install the programs

=head1 SYNOPSIS

 Install.PL [options]

=head1 DESCRIPTION

F<Install.PL> is a perl script to install perl programs. It
checks the environment, files and libraries, prompts for the
required settings, and then install the target program to
your system. It can simplify the installation, especially
for those that cannot modify perl scripts by themself.

If you're running perl 5.005 or earlier, you have to install
File::Spec::Functions manually for this program to run.
File::Spec::Functions is included in perl 5.6.0 or later.

Refer to the specific programs themself for the detailed
documentation on them.

=head1 OPTIONS

=over

=item -h, --help

Display this help and exit.

=item -v, --version

Output version information and exit.

=item -quiet, --silent

Shihhhhhh. Do not print the "checking..." messages. Only
ask questions and report errors.

=item -u, --uninstall

Reverse the last installation.

=item -i, --include=PATH

Add the PATH to @INC to search for perl modules. Use
multiple C<--include> to add multiple paths.

=back

Type "./Install --help" for detailed configuration options.

=head1 VERSION

2.1.2

=head1 COPYRIGHT

Copyright (c) 2001 imacat. All rights reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but I<WITHOUT ANY WARRANTY>; without even the implied warranty of
I<MERCHANTABILITY> or I<FITNESS FOR A PARTICULAR PURPOSE>.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

=head1 AUTHOR

imacat <imacat@mail.imacat.idv.tw>

=head1 BUGS

Please report if any. ^_*'

=head1 TODO

=over

=item Implementation to do conditional source

It should be possible to install the conditional perl source.
It could save the distination program size and remove the unnecessary
functions if users are not capable to employ them. Thus users are not
required to do what they can't do.

=head1 SEE ALSO

None
